package org.nustaq.kson;

/**
 * Copyright (c) 2012, Ruediger Moeller. All rights reserved.
 * <p/>
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * <p/>
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * <p/>
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301  USA
 * <p/>
 * Date: 20.12.13
 * Time: 12:03
 *
 * Created by ruedi on 07.08.2014.
 */
public class KsonStringOutput implements KsonCharOutput {

    StringBuilder builder = new StringBuilder();

    @Override
    public void writeChar(char c) {
        builder.append(c);
    }

    @Override
    public void writeString(String s) {
        builder.append(s);
    }

    @Override
    public char lastChar() {
        if ( builder.length() > 0 ) {
            return builder.charAt(builder.length()-1);
        }
        return 0;
    }

    @Override
    public void back(int i) {
        builder.setLength(builder.length()-i);
    }

    public StringBuilder getBuilder() {
        return builder;
    }

    public void setBuilder(StringBuilder builder) {
        this.builder = builder;
    }

    public String toString() {
        return builder.toString();
    }
}
